package com.jollychic.monitor

import com.jollychic.utils.DateUtils
import scalikejdbc.config.DBsWithEnv

/**
  *  人群分组标签
  *  【检查user_tags标签数据是否完成计算完成】
  */
object CheckUserGroupTag {

  def main(args: Array[String]): Unit = {

    // 今日日期
    val today = DateUtils.getNDayYMD(-1)
    val stage = "Cluster"

    // 检查用户标签UserTag数据是否正常产出
    def checkUserTagsState(stage:String,today:String):Long = {
      DBsWithEnv("monitor").setupAll()
      import scalikejdbc._
      val stateFun = (rs:WrappedResultSet)=> rs.long(1)
      val stateOpt = DB readOnly{
        implicit session=>
          sql"select state FROM tag_monitor_state where stage = ${stage} and process_date = ${today}"
            .map(stateFun).single().apply()
      }
      // 数据同步状态
      stateOpt.getOrElse(1)
    }
    // 检查的状态
    val checkState = checkUserTagsState(stage,today)

    if (checkState != 0) {
      println(
        """
          |UserGroupTag  [ dw_profile_user_tag_cookie 和 dw_profile_user_tag_userid  ] There may be a problem
        """.stripMargin)
      throw new RuntimeException(" UserGroupTag data is error ")
    } else {
      println(
        """
          |UserGroupTag data normal
        """.stripMargin)

    }

  }

}
