package com.jollychic.spark

import java.sql.{ResultSet, Statement}
import java.time.Year

import com.jollychic.tool.{ClickhouseConnect, TagGenBase}
import com.jollychic.utils.DateUtils

class Tag_DaWang_Long extends  TagGenBase{


  //生成大网长期更新数据标签
  def z_Long_tag_C_XXH_sp()={
    RunClickhouseSQL(s"drop table if exists  ads.XXH_ALL_MONTH_LONG");
    RunClickhouseSQL(s"drop table if exists  ads.ZT_USER_TAG_XXH_LONG");

    Thread.sleep(20000)
    z_L_tag_C_XXH(uid_l="0",uid_r="131",isInsert=false)
    z_L_tag_C_XXH(uid_l="131",uid_r="132",isInsert=true)
    z_L_tag_C_XXH(uid_l="132",uid_r="150",isInsert=true)
    z_L_tag_C_XXH(uid_l="150",uid_r="156",isInsert=true)
    z_L_tag_C_XXH(uid_l="156",uid_r="166",isInsert=true)
    z_L_tag_C_XXH(uid_l="166",uid_r="176",isInsert=true)
    z_L_tag_C_XXH(uid_l="176",uid_r="1768",isInsert=true)
    z_L_tag_C_XXH(uid_l="1768",uid_r="1855",isInsert=true)
    z_L_tag_C_XXH(uid_l="1855",uid_r="186",isInsert=true)
    z_L_tag_C_XXH(uid_l="186",uid_r="1865",isInsert=true)
    z_L_tag_C_XXH(uid_l="1865",uid_r="9999",isInsert=true)

    Thread.sleep(10000)
    zt_Long_tag_C_XXH(isInsert = false)
  }


  ///生成大网列标签 APP应用情况
  def z_L_tag_C_XXH(isInsert:Boolean=false,uid_l:String="",uid_r:String=""):Int = {
    var sql: String = ""
    var lr_UserSQL=if(uid_l=="") "" else s" and DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER <'${uid_r}'"
    if (isInsert == false) {
      sql = sql +
        """
          |create table ads.XXH_ALL_MONTH_LONG  ENGINE = MergeTree  ORDER BY DEVICE_NUMBER  as
          |""".stripMargin
    } else {
      sql = sql +
        """
          |insert into  ads.XXH_ALL_MONTH_LONG
          |""".stripMargin
    }


    sql=sql+
      s"""
         | select DEVICE_NUMBER ,any(PROV_DESC) PROV_DESC,
         |any(SERVICE_TYPE) SERVICE_TYPE,any(CUST_SEX) CUST_SEX,any(CERT_AGE) CERT_AGE,any(PRODUCT_CLASS_DESC) PRODUCT_CLASS_DESC
         |from
         |(
         |
         |  select  MONTH_ID, DEVICE_NUMBER ,if(s1.PROV_DESC=='',b.PROVINCE,s1.PROV_DESC) as PROV_DESC,SERVICE_TYPE ,CUST_SEX,CERT_AGE,PRODUCT_CLASS_DESC from (
         |	select MONTH_ID, DEVICE_NUMBER ,PROV_DESC,SERVICE_TYPE ,CUST_SEX,CERT_AGE,PRODUCT_CLASS_DESC from
         |	ads.XXH_ALL_MONTH
         |	where  MONTH_ID >='202101' and  DEVICE_NUMBER not in (select DEVICE_NUMBER from ads.XXH_KUAISHOU_MONTH where 1=1  ${lr_UserSQL})  ${lr_UserSQL}
         |  union all
         |  select MONTH_ID,DEVICE_NUMBER,  PROV_DESC, NULL as SERVICE_TYPE,if(CUST_SEX==1,'男','女') as CUST_SEX,
         |  multiIf((2021-CERT_AGE)>=2010,'10后',(2021-CERT_AGE)>=2000,'00后',(2021-CERT_AGE)>=1990,'90后',(2021-CERT_AGE)>=1980,'80后',
         |  (2021-CERT_AGE)>=1970,'70后',(2021-CERT_AGE)<1970,'70前','未知') as CERT_AGE,
         |  PRODUCT_CLASS_DESC
         |  from ads.XXH_KUAISHOU_MONTH where 1=1 ${lr_UserSQL}
         |  ) s1
         |  left join  ads.ETL_VW_TB_CALLER_AREACODE b on substring(s1.DEVICE_NUMBER , 1, 7) = b.CALLERHEAD
         |	order by MONTH_ID desc
         |) group by DEVICE_NUMBER
         |""".stripMargin+""

    printf(sql)
    //执行
    RunClickhouseSQL(sql);
    0
  }


  ///生成年周期-大网列标签
  def zt_Long_tag_C_XXH(isInsert:Boolean=false,uid_l:String="",uid_r:String=""):Int ={
    val maptags: Map[String, String]=get_alltags()

    var lr_UserSQL=if(uid_l=="") "" else s" and DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER <'${uid_r}'"

    var sql:String=""
    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_TAG_XXH_LONG  ENGINE = MergeTree ORDER BY DEVICE_NUMBER_XXH_L  as
          |SELECT DEVICE_NUMBER as DEVICE_NUMBER_XXH_L,
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_TAG_XXH_LONG
          |SELECT DEVICE_NUMBER,
          |""".stripMargin
    }

    sql=sql+GenSelectTagSql_C("性别","CUST_SEX")+",";
    sql=sql+GenSelectTagSql_C("省份","PROV_DESC")+",";
    sql=sql+GenSelectTagSql_C("网络类型","SERVICE_TYPE")+",";
    sql=sql+GenSelectTagSql_C("年龄阶段","CERT_AGE")+" ";
    //sql=sql+GenSelectTagSql_C("套餐","PRODUCT_CLASS_DESC")+",";

    sql=sql+
      s"""
         |from ads.XXH_ALL_MONTH_LONG where 1=1 ${lr_UserSQL}
         |""".stripMargin

    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

}
