package com.jollychic.spark

import com.jollychic.tool.SparkSQlTools
import com.jollychic.utils.DateUtils
import org.apache.spark.sql.SparkSession

/**
 * 未用未用未用
 */
/**
  * 提取 广告系统 用户人群数据
  *     【Hbase系统】
  */
object UserGroupTag2Hbase {

  def main(args: Array[String]): Unit = {

    if (args.length != 2) {
      System.err.println(
        """
          |Usage: UserGroupFilterTask  must input four parameter
          | 1st  is  a tableName for save the usegroup data
          | 2st  is  a target_system for push data to system
            | E.g:  "1000000563005027" OR "1000001164706258,1000001289038843"
        """.stripMargin)
      System.exit(1)
    }

    val spark = SparkSession
      .builder()
      .appName("userprofile-UserGroupTag2HbaseTable")
      .config("spark.serializer", "org.apache.spark.serializer.KryoSerializer")
      .enableHiveSupport()
      .getOrCreate()

    // 时间
    val nowDay = DateUtils.getNDay(-1)

    // 参数
      args(1).split(",").foreach(sys=>{
//        dw.dw_profile_service_hbase_user_group
      import spark.sql
        val sqlStr =
          s"""
            |INSERT OVERWRITE TABLE ${args(0)}
            |      PARTITION(data_date = '${nowDay}',target = '${sys}')
            |   select id,tagsmap, '','' from  dw.dw_profile_usergroup_tag
            |      where  data_date = '${nowDay}'and target = '${sys}'
            """.stripMargin
        // 执行
        sql(sqlStr)

        // 监控 具体前数据
        val memberQuantity: Long = sql(
          s"""
             |SELECT count(*) as cts from dw.dw_profile_usergroup_tag
             | where data_date = '${nowDay}'  AND target = '${sys}'
          """.stripMargin).collect()(0).getAs[Long]("cts")

        // 抵达Hbase系统数据数量
        val dataCount = sql(
          s"""
             |select count(*) as cts from dw.dw_profile_service_hbase_user_group
             | where  data_date = '${nowDay}' and target = '${sys}'
        """.stripMargin).collect()(0).getAs[Long]("cts")
        // 反向通知数据
        SparkSQlTools.noticeUserGroupDataLogs(
          -999999,dataCount,memberQuantity,"dw_profile_service_hbase_user_group",sys)
    })

    spark.stop()
  }

}
