package com.jollychic.spark

import com.jollychic.tool.SparkSQlTools
import com.jollychic.utils.DateUtils
import org.apache.spark.sql.SparkSession

/**
 * 未用未用未用
 */
/**
  * 各个业务系统用户标签合并
  */
object UserGroupTagTask {

  def main(args: Array[String]): Unit = {
    if (args.length != 1) {
      System.err.println(
        """
          |Usage: UserGroupFilterTask  must input four parameter
          | 1st  is  a tabName for save data of user group
        """.stripMargin)
      System.exit(1)
    }
    //dw.dw_profile_usergroup_tag
    val tabs = args(0)

    val spark = SparkSession
      .builder()
      .appName("userprofile-UserGroupTagTask")
      .config("spark.serializer", "org.apache.spark.serializer.KryoSerializer")
      .enableHiveSupport()
      .getOrCreate()

    //读取待聚合的标签
    import spark.sql

    // 时间
    val nowDay = DateUtils.getNDay(-1)

    // 提取业务需求方编号
    SparkSQlTools.readMySqlTab(spark,"user_category_target_system","v_target_sys")

    // 系统编码
    val sysCode: Array[String] = sql(
      """
        |SELECT system_code FROM v_target_sys
      """.stripMargin).collect().map {
      _.getAs[String]("system_code")
    }

    sysCode.foreach(code=>{

      //标签合并
      val v=
        s"""
           |INSERT OVERWRITE TABLE ${tabs} PARTITION(data_date = '$nowDay',target = '${code}')
           | SELECT tb.id ,str_to_map(concat_ws(',',collect_set(concat(tb.tagid,':','-999999')))) AS tagsmap,'',''
           | FROM (
           |     SELECT id, tagid,target  from dw.dw_profile_tag_usergroup
             |     where data_date = '$nowDay' AND target_sys = '${code}'
           | ) tb GROUP BY tb.id, tb.target
      """.stripMargin
      // 执行人群分组
      sql(v)
//      println(v)

      // 监控 具体前数据
      val memberQuantity: Long = sql(
        s"""
            |SELECT count(*) as cts from dw.dw_profile_tag_usergroup
            | where data_date = '${nowDay}'  AND target_sys = '${code}'
          """.stripMargin).collect()(0).getAs[Long]("cts")

      // 抵达推送系统聚合后数量
      val dataCount = sql(
        s"""
          |select count(*) as cts from ${tabs}
          | where  data_date = '${nowDay}' and target = '${code}'
        """.stripMargin).collect()(0).getAs[Long]("cts")

      SparkSQlTools.noticeUserGroupDataLogs(-999999,dataCount,memberQuantity,"dw_profile_usergroup_tag",code)
    })
    spark.stop()
  }
}
