package com.jollychic.utils

import java.util

import com.jollychic.constant.Constant
import com.typesafe.config.ConfigFactory

/**
 * 配置文件的数据读取工具
 **/
object ConstantUtils {

  // 加载配置文件
  private val config = ConfigFactory.load()

  /*------------------------MySQL 参数配置---------------------------------*/
  val DBS_DRIVER = config.getString(Constant.DB_DRIVER)
  val DBS_URL = config.getString(Constant.DB_URL)
  val DBS_USER = config.getString(Constant.DB_USER)
  val DBS_PASSWORD = config.getString(Constant.DB_PASSWORD)
  val DBS_TABLE = config.getString(Constant.DB_TABLE)


  /*------------------------MySQL 参数配置[监控]---------------------------------*/
  val DBS_MONITOR__DRIVER = config.getString(Constant.DB_MONITOR_DRIVER)
  val DBS_MONITOR_URL = config.getString(Constant.DB_MONITOR_URL)
  val DBS_MONITOR_USER = config.getString(Constant.DB_MONITOR_USER)
  val DBS_MONITOR_PASSWORD = config.getString(Constant.DB_MONITOR_PASSWORD)
  val DBS_MONITOR_TABLE = config.getString(Constant.DB_MONITOR_TABLE)

  /*------------------------oracle---------------------------------*/
  val ORACALDB_DRIVER = config.getString(Constant.ORACALDB_DRIVER)
  val ORACALDB_URL = config.getString(Constant.ORACALDB_URL)
  val ORACALDB_USER = config.getString(Constant.ORACALDB_USER)
  val ORACALDB_PASSWORD = config.getString(Constant.ORACALDB_PASSWORD)

  val ES_HOST = config.getString(Constant.ES_HOST)
  val ES_CLUSTER = config.getString(Constant.ES_CLUSTER)
  val ES_USER = config.getString(Constant.ES_USER)
  val ES_PASSWORD = config.getString(Constant.ES_PASSWORD)


  val CH_DRIVER = config.getString(Constant.CH_DRIVER)
  val CH_URL = config.getString(Constant.CH_URL)
  val CH_USER = config.getString(Constant.CH_USER)
  val CH_PASSWORD = config.getString(Constant.CH_PASSWORD)
  val CH_URL_TEST = config.getString(Constant.CH_URL_TEST)
  val CH_USER_TEST = config.getString(Constant.CH_USER_TEST)
  val CH_PASSWORD_TEST = config.getString(Constant.CH_PASSWORD_TEST)
  //  /*----------------------- 人群过滤参数配置---------------------------------*/
////  val TASK_FILTED_CROWD = config.getString(Constant.FILTERD_CROWD_TASK)
  private val map: util.Map[String, AnyRef] = config.getObject(Constant.FILTERD_USER_GROUP_TASK_DESC).unwrapped()
//
  val TASK_FILTED_USER_GROUP_IN_CK = map.get(Constant.FILTERD_USER_GROUP_TASK_CK_IDTABS).asInstanceOf[String]
  val TASK_FILTED_USER_GROUP_IN_US = map.get(Constant.FILTERD_USER_GROUP_TASK_US_IDTABS).asInstanceOf[String]


  // 人群预估因子
  val PREDIC_FACTOR: Double = config.getDouble(Constant.SPARK_USER_GROUP_PREDIC_FACTOR)

}
