package com.jollychic.utils

import java.text.SimpleDateFormat
import java.util.{Calendar, Date}

/**
  *  时间工具类
  */
object DateUtils {

  private  val DATE_PATTERN = "yyyyMMdd"

  private  val DATETIME_PATTERN = "yyyy-MM-dd HH:mm:ss"

  private  val DATETIME_PATTERN_YMD = "yyyy-MM-dd"

  /**
    * 获取当前系统日期
    * @return
    */
  def nowDate(pattern:String=DATE_PATTERN) ={
    val now: Date = new Date()
    val dateFormat: SimpleDateFormat = new SimpleDateFormat(pattern)
    val date = dateFormat.format(now)
    date
  }

  /**
    * 获取当前系统时间
    * @return
    */
  def nowDateTime ={
    val now: Date = new Date()
    val dateFormat: SimpleDateFormat = new SimpleDateFormat(DATETIME_PATTERN)
    val datetime = dateFormat.format(now)
    datetime
  }

  /**
    * 获取 N Day  默认返回当前系统日期
    * @param n n < 0  提前n天前   n > 0  提前n天后
    * @return
    */
  def getNDay(n:Int = 0) = {
    val  dateFormat:SimpleDateFormat = new SimpleDateFormat(DATE_PATTERN)
    val cal:Calendar=Calendar.getInstance()
    cal.add(Calendar.DATE,n)
    dateFormat.format(cal.getTime())
  }

  /***
   * 获取给定时间的n个月diff
   * @param dateStr
   * @param n
   * @return
   */
  def getNMonth(dateStr:String, n:Int = 0,pattern:String=DATETIME_PATTERN_YMD) = {
    val  dateFormat:SimpleDateFormat = new SimpleDateFormat(DATETIME_PATTERN_YMD)
    val dt = dateFormat.parse(dateStr);
    val rightNow = Calendar.getInstance();
    rightNow.setTime(dt);
    rightNow.add(Calendar.MONTH, n);
    if(pattern==DATETIME_PATTERN_YMD){
      dateFormat.format(rightNow.getTime())
    }else{
      new SimpleDateFormat(pattern).format(rightNow.getTime())
    }

  }

  def getMMonth(dateStr:String, n:Int = 0,pattern:String=DATETIME_PATTERN) = {
    val  dateFormat:SimpleDateFormat = new SimpleDateFormat(pattern)
    val dt = dateFormat.parse(dateStr);
    val rightNow = Calendar.getInstance();
    rightNow.setTime(dt);
    rightNow.add(Calendar.MONTH, n);
    new SimpleDateFormat(pattern).format(rightNow.getTime())
  }

  /**
    * 获取 N Day  默认返回当前系统日期
    * @param n n < 0  提前n天前   n > 0  提前n天后
    * @return
    */
  def getNDayYMD(n:Int = 0) = {
    val  dateFormat:SimpleDateFormat = new SimpleDateFormat(DATETIME_PATTERN_YMD)
    val cal:Calendar=Calendar.getInstance()
    cal.add(Calendar.DATE,n)
    dateFormat.format(cal.getTime())
  }

}
