package com.jollychic.utils;

import org.apache.http.HttpHost;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.impl.client.BasicCredentialsProvider;
import org.apache.http.impl.nio.client.HttpAsyncClientBuilder;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestClientBuilder;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.common.settings.Settings;

public class ElasticSearchConfig {

    private static String hostlist=ConstantUtils.ES_HOST();
    private static String cluster=ConstantUtils.ES_CLUSTER();
    private static String username=ConstantUtils.ES_USER();
    private static String password=ConstantUtils.ES_PASSWORD();

//    private static String hostlist="";
//    private static String cluster="";
//    private static String username="";
//    private static String password="";

    public static RestHighLevelClient restHighLevelClient() {

        Settings settings = Settings.builder().put("cluster.name",cluster).build();
        //解析hostlist配置信息
        String[] split = hostlist.split(",");
        //创建HttpHost数组，其中存放es主机和端口的配置信息
        HttpHost[] httpHostArray = new HttpHost[split.length];
        for (int i = 0; i < split.length; i++) {
            String item = split[i];
            System.out.println("item "+ item);
            httpHostArray[i] = new HttpHost(item.split(":")[0], Integer.parseInt(item.split(":")[1]), "http");
            System.out.println("httpHostArray" + httpHostArray[i]);
        }
        CredentialsProvider credentialsProvider = new BasicCredentialsProvider();
        credentialsProvider.setCredentials(AuthScope.ANY,new UsernamePasswordCredentials(username, password));

        RestClientBuilder builder =RestClient.builder(httpHostArray) .setHttpClientConfigCallback(new RestClientBuilder.HttpClientConfigCallback() {
            @Override
            public HttpAsyncClientBuilder customizeHttpClient(HttpAsyncClientBuilder httpAsyncClientBuilder) {
                return httpAsyncClientBuilder.setDefaultCredentialsProvider(credentialsProvider);
            }
        }).setRequestConfigCallback(new RestClientBuilder.RequestConfigCallback() {
            @Override
            public RequestConfig.Builder customizeRequestConfig(RequestConfig.Builder requestBuilder) {
                requestBuilder.setConnectTimeout(2000);
                requestBuilder.setSocketTimeout(2000);
                requestBuilder.setConnectionRequestTimeout(1000);
                return requestBuilder;
            }
        });
        //创建RestHighLevelClient客户端
        return new RestHighLevelClient(builder);
    }

}

